---
title: 'get RegExp[@@species]'
slug: Web/JavaScript/Reference/Global_Objects/RegExp/@@species
tags:
  - JavaScript
  - Property
  - Prototype
  - Reference
  - RegExp
  - Regular Expressions
---
<div>{{JSRef}}</div>

<p>The <strong><code>RegExp[@@species]</code></strong> accessor property returns the <code>RegExp</code> constructor.</p>

<div>{{EmbedInteractiveExample("pages/js/regexp-getregexp-@@species.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Description">Description</h2>

<p>The <code>species</code> accessor property returns the default constructor for <code>RegExp</code> objects. Subclass constructors may over-ride it to change the constructor assignment.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Species_in_ordinary_objects">Species in ordinary objects</h3>

<p>The <code>species</code> property returns the default constructor function, which is the <code>RegExp</code> constructor for <code>RegExp</code> objects:</p>

<pre class="brush: js notranslate">RegExp[Symbol.species]; // function RegExp()</pre>

<h3 id="Species_in_derived_objects">Species in derived objects</h3>

<p>In a derived collection object (e.g. your custom regexp <code>MyRegExp</code>), the <code>MyRegExp</code> species is the <code>MyRegExp</code> constructor. However, you might want to overwrite this, in order to return parent <code>RegExp</code> objects in your derived class methods:</p>

<pre class="brush: js notranslate">class MyRegExp extends RegExp {
  // Overwrite MyRegExp species to the parent RegExp constructor
  static get [Symbol.species]() { return RegExp; }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-get-regexp-@@species', 'get RegExp [ @@species ]')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.RegExp.@@species")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("RegExp")}}</li>
 <li>{{jsxref("Symbol.species")}}</li>
</ul>
